;;; Gacela, a GNU Guile extension for fast games development
;;; Copyright (C) 2017 by Javier Sancho Fernandez <jsf at jsancho dot org>
;;;
;;; This program is free software: you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation, either version 3 of the License, or
;;; (at your option) any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (gacela event)
  #:use-module ((sdl2 events) #:prefix sdl2:)
  #:export (process-events
	    quit?))


(define *current-events* '())

(define (poll-events)
  (let ((event (sdl2:poll-event)))
    (cond (event
	   (cons event (poll-events)))
	  (else
	   '()))))

(define (process-events)
  (set! *current-events* (poll-events)))

(define (quit?)
  (not (null? (filter (lambda (e) (sdl2:quit-event? e)) *current-events*))))
