;;; Gacela, a GNU Guile extension for fast games development
;;; Copyright (C) 2013 by Javier Sancho Fernandez <jsf at jsancho dot org>
;;;
;;; This program is free software: you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation, either version 3 of the License, or
;;; (at your option) any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program.  If not, see <http://www.gnu.org/licenses/>.

(define-module (gacela entity)
  #:use-module (bongodb)
  #:export (make-entity-set
	    add-entities
	    entities-count))

(define (make-entity-set . entities)
  (add-entities (make-collection) entities))

(define (add-entities entity-set . entities)
  (let ((entities (filter
		   (lambda (e) (not (null? e)))
		   entities)))
    (cond (entities
	   (apply insert (cons entity-set entities)))
	  (else
	   entity-set))))

(define (entities-count entity-set)
  (count entity-set))
