;;; Gacela, a GNU Guile extension for fast games development
;;; Copyright (C) 2016 by Javier Sancho Fernandez <jsf at jsancho dot org>
;;;
;;; This program is free software: you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation, either version 3 of the License, or
;;; (at your option) any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program.  If not, see <http://www.gnu.org/licenses/>.

(use-modules (gacela entity)
	     (ice-9 receive)
	     (srfi srfi-64))

(test-begin "entities")

(define entity-set (make-entity-set))
(define key #f)

; Creating entities

(receive (e k) (add-entities entity-set '((a . (1 2)) (b . #f)))
  (set! entity-set e)
  (set! key (car k)))
(set! entity-set (add-entities entity-set '((a . (10 20)))))
(add-entities entity-set '((a . (10 20))))
(test-eqv 2 (entities-count entity-set))

;; (define-component a x y)
;; (define-component b)

;; (define entities (make-entity-set))
;; (define key #f)

;; ; Modifying entities
;; (define component (assoc-ref (get-entity entities key) 'a))
;; (test-eqv 1 (a-x component))
;; (test-eqv 2 (a-y component))

(test-end "entities")
